## breezy 3.0.0~bzr6819

=== Makefile ===
# Copyright (C) 2005-2012, 2016, 2017 Canonical Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# A relatively simple Makefile to assist in building parts of brz. Mostly for
# building documentation, etc.


### Core Stuff ###

PYTHON?=python
PYTHON3?=python3
PYTHON24=python24
PYTHON25=python25
PYTHON26=python26
BRZ_TARGET=release
PLUGIN_TARGET=plugin-release
PYTHON_BUILDFLAGS=
BRZ_PLUGIN_PATH=-site:-user

# Shorter replacement for $(sort $(wildcard <arg>)) as $(call sw,<arg>)
sw = $(sort $(wildcard $(1)))


.PHONY: all clean realclean extensions pyflakes api-docs check-nodocs check

all: extensions

extensions:
	@echo "building extension modules."
	$(PYTHON) setup.py build_ext -i $(PYTHON_BUILDFLAGS)

check: docs check-nodocs

check-nodocs: check-nodocs2 check-nodocs3

check-nodocs3:
	# Generate a stream for PQM to watch.
	-$(RM) -f selftest.log
	echo `date` ": selftest starts" 1>&2
	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Wignore::ImportWarning -O \
	  ./brz selftest -Oselftest.timeout=120 --load-list=python3.passing \
	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
	echo `date` ": selftest ends" 1>&2
	# An empty log file should catch errors in the $(PYTHON3)
	# command above (the '|' swallow any errors since 'make'
	# sees the 'tee' exit code for the whole line
	if [ ! -s selftest.log ] ; then exit 1 ; fi
	# Check that there were no errors reported.
	subunit-stats < selftest.log

update-python3-passing:
	# Generate a stream for PQM to watch.
	-$(RM) -f selftest.log
	-BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -O \
	  ./brz selftest -Oselftest.timeout=120 \
	  --subunit2 $(tests) > selftest.log
	grep -v "^#" python3.passing > python3.passing.new
	cat selftest.log | \
	  subunit-filter --no-failure --no-error --success | \
	  subunit-ls --no-passthrough >> python3.passing.new
	cp python3.passing python3.passing.old
	grep "^#" python3.passing.old > python3.passing
	sort -u python3.passing.new >> python3.passing

check-nodocs2: extensions
	# Generate a stream for PQM to watch.
	-$(RM) -f selftest.log
	echo `date` ": selftest starts" 1>&2
	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -O \
	  ./brz selftest -Oselftest.timeout=120 \
	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
	echo `date` ": selftest ends" 1>&2
	# An empty log file should catch errors in the $(PYTHON)
	# command above (the '|' swallow any errors since 'make'
	# sees the 'tee' exit code for the whole line
	if [ ! -s selftest.log ] ; then exit 1 ; fi
	# Check that there were no errors reported.
	subunit-stats < selftest.log

# Run Python style checker (apt-get install pyflakes)
#
# Note that at present this gives many false warnings, because it doesn't
# know about identifiers loaded through lazy_import.
pyflakes:
	pyflakes breezy

pyflakes-nounused:
	# There are many of these warnings at the moment and they're not a
	# high priority to fix
	pyflakes breezy | grep -v ' imported but unused'

clean:
	$(PYTHON) setup.py clean
	-find . -name "*.pyc" -o -name "*.pyo" -o -name "*.so" | xargs rm -f

realclean: clean
	# Remove files which are autogenerated but included by the tarball.
	rm -f breezy/*_pyx.c
	rm -f breezy/_simple_set_pyx.h breezy/_simple_set_pyx_api.h

# Build API documentation
docfiles = brz breezy
api-docs:
	mkdir -p api/html
	pydoctor --make-html --docformat='restructuredtext' --html-output=api/html $(docfiles)

# build tags for emacs and vim
TAGS:
	ctags -R -e breezy

tags:
	ctags -R breezy

# these are treated as phony so they'll always be rebuilt - it's pretty quick
.PHONY: TAGS tags


### Documentation ###

# Default to plain documentation for maximum backwards compatibility.
# (Post 2.0, the defaults will most likely be Sphinx-style instead.)

docs: docs-plain

clean-docs: clean-plain

html-docs: html-plain


### Man-page Documentation ###

MAN_DEPENDENCIES = breezy/builtins.py \
	$(call sw,breezy/*.py) \
	$(call sw,breezy/*/*.py) \
	tools/generate_docs.py \
	$(call sw,$(addsuffix /*.txt, breezy/help_topics/en)) 

MAN_PAGES = man1/brz.1
man1/brz.1: $(MAN_DEPENDENCIES)
	$(PYTHON) tools/generate_docs.py -o $@ man


### Sphinx-style Documentation ###

# Build the documentation. To keep the dependencies down to a minimum
# for distro packagers, we only build the html documentation by default.
# Sphinx 0.6 or later is preferred for the best rendering, though
# Sphinx 0.4 or later should work. See http://sphinx.pocoo.org/index.html
# for installation instructions.
docs-sphinx: html-sphinx

# Clean out generated documentation
clean-sphinx:
	cd doc/en && make clean
	cd doc/developers && make clean

SPHINX_DEPENDENCIES = \
        doc/en/release-notes/index.txt \
        doc/en/user-reference/index.txt \
	doc/developers/Makefile \
	doc/developers/make.bat

NEWS_FILES = $(call sw,doc/en/release-notes/brz-*.txt)

doc/en/user-reference/index.txt: $(MAN_DEPENDENCIES)
	LANGUAGE=C $(PYTHON) tools/generate_docs.py -o $@ rstx

doc/en/release-notes/index.txt: $(NEWS_FILES) tools/generate_release_notes.py
	$(PYTHON) tools/generate_release_notes.py $@ $(NEWS_FILES)

doc/%/Makefile: doc/en/Makefile
	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"

doc/%/make.bat: doc/en/make.bat
	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"

# Build the html docs using Sphinx.
html-sphinx: $(SPHINX_DEPENDENCIES)
	cd doc/en && make html
	cd doc/developers && make html

# Build the PDF docs using Sphinx. This requires numerous LaTeX
# packages. See http://sphinx.pocoo.org/builders.html for details.
# Note: We don't currently build PDFs for the Russian docs because
# they require additional packages to be installed (to handle
# Russian hyphenation rules, etc.)
pdf-sphinx: $(SPHINX_DEPENDENCIES)
	cd doc/en && make latex
	cd doc/developers && make latex
	cd doc/en/_build/latex && make all-pdf
	cd doc/developers/_build/latex && make all-pdf

# Build the CHM (Windows Help) docs using Sphinx.
# Note: HtmlHelp Workshop needs to be used on the generated hhp files
# to generate the final chm files.
chm-sphinx: $(SPHINX_DEPENDENCIES)
	cd doc/en && make htmlhelp
	cd doc/developers && make htmlhelp


# Build the texinfo files using Sphinx.
texinfo-sphinx: $(SPHINX_DEPENDENCIES)
	cd doc/en && make texinfo
	cd doc/developers && make texinfo

### Documentation Website ###

# Where to build the website
DOC_WEBSITE_BUILD = build_doc_website

# Build and package docs into a website, complete with downloads.
doc-website: html-sphinx pdf-sphinx
	$(PYTHON) tools/package_docs.py doc/en $(DOC_WEBSITE_BUILD)
	$(PYTHON) tools/package_docs.py doc/developers $(DOC_WEBSITE_BUILD)


### Plain Documentation ###

# While Sphinx is the preferred tool for building documentation, we still
# support our "plain" html documentation so that Sphinx is not a hard
# dependency for packagers on older platforms.

rst2html = $(PYTHON) tools/rst2html.py --link-stylesheet --footnote-references=superscript --halt=warning

# translate txt docs to html
derived_txt_files = \
	doc/en/release-notes/NEWS.txt
txt_all = \
	doc/en/tutorials/tutorial.txt \
	doc/en/tutorials/using_breezy_with_launchpad.txt \
	doc/en/tutorials/centralized_workflow.txt \
	$(call sw,doc/*/mini-tutorial/index.txt) \
	$(call sw,doc/*/user-guide/index-plain.txt) \
	doc/en/admin-guide/index-plain.txt \
	$(call sw,doc/es/guia-usario/*.txt) \
	$(derived_txt_files) \
	doc/en/upgrade-guide/index.txt \
	doc/index.txt \
	$(call sw,doc/index.*.txt)
txt_nohtml = \
	doc/en/user-guide/index.txt \
	doc/en/admin-guide/index.txt
txt_files = $(filter-out $(txt_nohtml), $(txt_all))
htm_files = $(patsubst %.txt, %.html, $(txt_files)) 

non_txt_files = \
       doc/default.css \
       $(call sw,doc/*/brz-en-quick-reference.svg) \
       $(call sw,doc/*/brz-en-quick-reference.png) \
       $(call sw,doc/*/brz-en-quick-reference.pdf) \
       $(call sw,doc/*/bzr-es-quick-reference.svg) \
       $(call sw,doc/*/bzr-es-quick-reference.png) \
       $(call sw,doc/*/bzr-es-quick-reference.pdf) \
       $(call sw,doc/*/bzr-ru-quick-reference.svg) \
       $(call sw,doc/*/bzr-ru-quick-reference.png) \
       $(call sw,doc/*/bzr-ru-quick-reference.pdf) \
       $(call sw,doc/*/user-guide/images/*.png)

# doc/developers/*.txt files that should *not* be individually
# converted to HTML
dev_txt_nohtml = \
	doc/developers/add.txt \
	doc/developers/annotate.txt \
	doc/developers/bundle-creation.txt \
	doc/developers/commit.txt \
	doc/developers/diff.txt \
	doc/developers/directory-fingerprints.txt \
	doc/developers/gc.txt \
	doc/developers/implementation-notes.txt \
	doc/developers/incremental-push-pull.txt \
	doc/developers/index.txt \
	doc/developers/initial-push-pull.txt \
	doc/developers/merge-scaling.txt \
	doc/developers/miscellaneous-notes.txt \
	doc/developers/missing.txt \
	doc/developers/performance-roadmap-rationale.txt \
	doc/developers/performance-use-case-analysis.txt \
	doc/developers/planned-change-integration.txt \
	doc/developers/planned-performance-changes.txt \
	doc/developers/plans.txt \
	doc/developers/process.txt \
	doc/developers/revert.txt \
	doc/developers/specifications.txt \
	doc/developers/status.txt \
	doc/developers/uncommit.txt

dev_txt_all = $(call sw,$(addsuffix /*.txt, doc/developers))
dev_txt_files = $(filter-out $(dev_txt_nohtml), $(dev_txt_all))
dev_htm_files = $(patsubst %.txt, %.html, $(dev_txt_files)) 

doc/en/user-guide/index-plain.html: $(call sw,$(addsuffix /*.txt, doc/en/user-guide))
	$(rst2html) --stylesheet=../../default.css $(dir $@)index-plain.txt $@

#doc/es/user-guide/index.html: $(call sw,$(addsuffix /*.txt, doc/es/user-guide))
#	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@
#
#doc/ru/user-guide/index.html: $(call sw,$(addsuffix /*.txt, doc/ru/user-guide))
#	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@
#
doc/en/admin-guide/index-plain.html: $(call sw,$(addsuffix /*.txt, doc/en/admin-guide))
	$(rst2html) --stylesheet=../../default.css $(dir $@)index-plain.txt $@

doc/developers/%.html: doc/developers/%.txt
	$(rst2html) --stylesheet=../default.css $< $@

doc/index.html: doc/index.txt
	$(rst2html) --stylesheet=default.css $< $@

doc/index.%.html: doc/index.%.txt
	$(rst2html) --stylesheet=default.css $< $@

%.html: %.txt
	$(rst2html) --stylesheet=../../default.css $< "$@"

doc/en/release-notes/NEWS.txt: $(NEWS_FILES) tools/generate_release_notes.py
	$(PYTHON) tools/generate_release_notes.py "$@" $(NEWS_FILES)

upgrade_guide_dependencies =  $(call sw,$(addsuffix /*.txt, doc/en/upgrade-guide))

doc/en/upgrade-guide/index.html: $(upgrade_guide_dependencies)
	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@

derived_web_docs = $(htm_files) $(dev_htm_files) 
WEB_DOCS = $(derived_web_docs) $(non_txt_files)
ALL_DOCS = $(derived_web_docs) $(MAN_PAGES)

# the main target to build all the docs
docs-plain: $(ALL_DOCS)

# produce a tree containing just the final docs, ready for uploading to the web
HTMLDIR = html_docs
html-plain: docs-plain
	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) $(HTMLDIR)

# clean produced docs
clean-plain:
	$(PYTHON) tools/win32/ostools.py remove $(ALL_DOCS) \
	    $(HTMLDIR) $(derived_txt_files)


### Miscellaneous Documentation Targets ###

# build a png of our performance task list

=== debian/changelog ===
breezy (3.0.0~bzr6819-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 19 Nov 2017 19:11:16 +0000

breezy (3.0.0~bzr6803-1) unstable; urgency=medium

  * Bump standards version to 4.1.1 (no changes).
  * New upstream snapshot.
  * Drop 04_remove_outdated_docs, applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 11 Nov 2017 13:11:54 +0000

breezy (3.0.0~bzr6792-3) unstable; urgency=medium

  * Add 14_test_server: Fix test_server test failure on FreeBSD.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 08 Oct 2017 16:30:44 +0100

breezy (3.0.0~bzr6792-2) unstable; urgency=medium

  * Add 04_remove_outdated_docs: Drop outdated documentation.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 07 Oct 2017 16:56:42 +0100

breezy (3.0.0~bzr6792-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch 02_diff_language: set LANGUAGE when running diff in tests.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 05 Oct 2017 23:48:13 +0100

breezy (3.0.0~bzr6791-1) unstable; urgency=medium

  * Use https VCS-* URLs in debian/control.
  * Depend on cython, breezy doesn't support pyrex.
  * New upstream snapshot.
  * Re-enable launchpad plugin - it should work offline now.
  * Depend on cython >= 0.17. Older versions don't support
    absolute_import.
  * Bump standards version to 4.1.0 (no changes).
  * Drop upstream (Bazaar) signing key.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 27 Sep 2017 23:35:10 +0100

breezy (3.0.0~bzr6772-1) unstable; urgency=medium

  * New upstream snapshot.
  * Run testsuite with LC_ALL=C.UTF-8. Closes: #873676

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 30 Aug 2017 05:09:42 +0000

breezy (3.0.0~bzr6753-1) unstable; urgency=medium

  * New upstream snapshot.
   + Use python-gpg rather than python-gpgme.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 10 Aug 2017 21:08:44 +0000

breezy (3.0.0~bzr6706-1) unstable; urgency=medium

  * Mark as supporting only Python >= 2.7.
  * Drop unnecessary Breaks that are only relevant for bzr.
  * Drop other bzr uploaders.
  * Add /usr/bin/brz as alternative for /usr/bin/bzr.
  * New upstream snapshot.
  * Drop patch 17_reproducible_makefile, applied upstream.
  * Drop patch 22_test_copy_to, applied upstream.
  * New upstream snapshot.
  * Bump standards version to 4.0.0 (no changes).

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 17 Jun 2017 16:24:46 +0000

breezy (3.0.0~bzr6644-1) experimental; urgency=medium

  * Rename package to breezy and explain fork. Closes: #863744
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 31 May 2017 01:08:44 +0000

bzr (2.7.0+bzr6619-8) unstable; urgency=high

  * Update 23_ssl_host: Actually pass server_hostname to
    ssl.socket_wrap.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Tue, 17 Jan 2017 00:20:26 +0000

bzr (2.7.0+bzr6619-7) unstable; urgency=medium

  * Add patch 23_ssl_host: avoid extra checking of server cert. Closes:
    #850960

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 11 Jan 2017 23:48:19 +0000

bzr (2.7.0+bzr6619-6) unstable; urgency=low

  * Disable lzma support on m68k, powerpcspe, sh4 where python-lzma is
    not available.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 26 Dec 2016 00:38:32 +0000

bzr (2.7.0+bzr6619-5) unstable; urgency=low

  * Order files by name when eliminating dupes, in an attempt to make
    the build reproducible.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 25 Dec 2016 14:41:05 +0000

bzr (2.7.0+bzr6619-4) unstable; urgency=medium

  * Add patch 22_test_copy_to: skip test_copy_to, as it's failing on
    armel.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 07 Dec 2016 22:12:55 +0000

bzr (2.7.0+bzr6619-3) unstable; urgency=medium

  * Fix compatibility with python2.7 2.7.12-7. Patch by Vincent.
    Closes: #845335 LP: #1644003
  * Sanitize URL scheme when running HTTP proxy tests for curl.
    LP: #1645017

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 26 Nov 2016 16:17:06 +0000

bzr (2.7.0+bzr6619-2) unstable; urgency=medium

  * Add 18_diff_binaries: With diffutils > 3.5, diff stop exiting with '2'
    on binary files. LP: #1622039
    Closes: #837268

  * Add 19_fix_long_creds: Fix http Basic auth with credentials longer
    than ~57 characters. LP: #1606203

 -- Vincent Ladeuil <v.ladeuil+lp@free.fr>  Fri, 09 Sep 2016 16:00:49 +0200

bzr (2.7.0+bzr6619-1) unstable; urgency=medium

  * Bump standards version to 3.9.8 (no changes).
  * New upstream snapshot.
  * Be consistent in what file is the target of symlinks when creating
    symlinks for documentation.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 06 Jun 2016 19:18:34 +0000

bzr (2.7.0-7) unstable; urgency=low

  * Add patch 17_reproducible_makefile: Fix order of documentation files
    processing in Makefiles, making build reproducible.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 06 Jun 2016 18:38:42 +0000

bzr (2.7.0-6) unstable; urgency=low

  * Set PYTHONHASHSEED to 0 when building sphinx docs, to force
    reproducible build.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 15 May 2016 18:31:28 +0000

bzr (2.7.0-5) unstable; urgency=medium

  * Enable PGP checking of upstream tarball.
  * Cope with paramiko making argument to SFTPFile.prefetch() mandatory.
    Closes: #822116

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 09 Apr 2016 14:45:18 +0000

bzr (2.7.0-4) unstable; urgency=low

  * Add patch 15_autodoc_source_epoch: Support SOURCE_DATE_EPOCH for
    timestamp used in manpages. Improves reproducibility.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 09 Apr 2016 13:54:38 +0000

bzr (2.7.0-3) unstable; urgency=low

  * Add Vincent to uploaders.
  * Add 14_en_user_guide patch: Make bzr build more reproducible: when
    locale is set to French, don't leak French phrases into English user-
    reference. LP: #1565503
  * Bump standards version to 3.9.7 (no changes).

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 21 Feb 2016 23:27:48 +0000

bzr (2.7.0-2) unstable; urgency=medium



=== debian/control ===
Source: breezy
Section: vcs
Priority: optional
Maintainer: Debian Breezy Maintainers <pkg-bazaar-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>
Build-Depends: bash-completion,
               ca-certificates,
               cython-dbg (>= 0.17),
               debhelper (>= 9),
               fdupes,
               python (>= 2.6.6-3),
               python-all-dbg (>= 2.6.6-3),
               python-all-dev (>= 2.6.6-3),
               python-configobj (>= 4.7.2+ds-2),
               python-docutils,
               python-fastimport,
               python-lzma-dbg [!m68k !powerpcspe !sh4],
               python-meliae-dbg,
               python-paramiko (<< 1.12.0) | python-paramiko (>= 1.14.1),
               python-sphinx (>= 1.0.7+dfsg),
               python-subunit,
               python-testtools (>= 0.9.5~)
Build-Conflicts: python-pyftpdlib
Standards-Version: 4.1.1
X-Python-Version: >= 2.7
Vcs-Bzr: https://anonscm.debian.org/bzr/pkg-bazaar/breezy/3.0
Vcs-Browser: https://bzr.debian.org/loggerhead/pkg-bazaar/breezy/3.0
Homepage: https://launchpad.net/brz
XS-Testsuite: autopkgtest

Package: brz
Recommends: python-gpg
Architecture: all
Depends: python-breezy (<= ${source:Version}.1~),
         python-breezy (>= ${source:Version}),
         ${misc:Depends},
         ${python:Depends}
Conflicts: bzr (<< 2.7.0+bzr6622-1)
Suggests: brz-doc,
          python-breezy.tests,
          python-fastimport
Description: easy to use distributed version control system
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many workflows, reliable, and
 easily extendable.
 .
 Publishing of branches can be done over plain HTTP, that is, no special
 software is needed on the server to host Breezy branches. Branches can
 be pushed to the server via sftp (which most SSH installations come
 with), FTP, or over a custom and faster protocol if brz is installed in
 the remote end.
 .
 Merging in Breezy is easy, as the implementation is able to avoid many
 spurious conflicts, deals well with repeated merges between branches,
 and is able to handle modifications to renamed files correctly.
 .
 Install python-paramiko if you are going to push branches to remote
 hosts with sftp.

Package: python-breezy
Architecture: any
Section: python
Depends: python-configobj,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            python-launchpadlib,
            ssh-client | python-paramiko
Conflicts: python-paramiko (<< 1.14.1)
Suggests: python-breezy-dbg,
          python-breezy.tests,
          python-fastimport,
          python-gpg,
          python-kerberos (>= 1.0+svn2455-1),
          python-paramiko,
          xdg-utils
Provides: ${python:Provides}
Description: distributed version control system - python library
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many workflows, reliable, and
 easily extendable.
 .
 This package contains the Breezy Python library.
 .
 Install python-paramiko for sftp transport support.

Package: python-breezy-dbg
Architecture: any
Section: debug
Depends: python-breezy (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Provides: ${python:Provides}
Recommends: python-dbg
Suggests: python-gpg-dbgsym,
          python-lzma-dbg,
          python-meliae-dbg
Description: distributed version control system - debug extension
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many workflows, reliable, and
 easily extendable.
 .
 This package contains the debug extension for the Breezy Python library.

Package: python-breezy.tests
Architecture: all
Section: python
Depends: python-breezy (<= ${source:Version}.1~),
         python-breezy (>= ${source:Version}),
         python-testtools (>= 0.9.5~),
         ${misc:Depends},
         ${python:Depends}
Suggests: python-subunit, python-pyftpdlib
Provides: ${python:Provides}
Replaces: python-breezy (<< 2.4.0~beta1-2)
Description: distributed version control system - testsuite
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many workflows, reliable, and
 easily extendable.
 .
 This package contains the breezy test infrastructure and testsuite,
 which is required to run the 'brz selftest' command and to run
 plugin tests.

Package: brz-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: brz
Description: easy to use distributed version control system (documentation)
 Breezy is a distributed version control system designed to be easy to
 use and intuitive, able to adapt to many workflows, reliable, and
 easily extendable.
 .
 Publishing of branches can be done over plain HTTP, that is, no special
 software is needed on the server to host Breezy branches. Branches can
 be pushed to the server via sftp (which most SSH installations come
 with), FTP, or over a custom and faster protocol if brz is installed in
 the remote end.
 .
 Merging in Breezy is easy, as the implementation is able to avoid many
 spurious conflicts, deals well with repeated merges between branches,
 and is able to handle modifications to renamed files correctly.
 .
 This package provides the documentation.

## breezy 3.0.0~bzr6833

=== debian/changelog ===
breezy (3.0.0~bzr6833-1) unstable; urgency=low

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 04 Dec 2017 01:23:39 +0000

## breezy 3.0.0~bzr6852

=== Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
 	echo `date` ": selftest starts" 1>&2
-	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Wignore::ImportWarning -O \
+	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
 	  ./brz selftest -Oselftest.timeout=120 --load-list=python3.passing \
 	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
 	echo `date` ": selftest ends" 1>&2
@@ -64,7 +64,7 @@
 update-python3-passing:
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
-	-BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -O \
+	-BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
 	  ./brz selftest -Oselftest.timeout=120 \
 	  --subunit2 $(tests) > selftest.log
 	grep -v "^#" python3.passing > python3.passing.new
@@ -79,7 +79,7 @@
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
 	echo `date` ": selftest starts" 1>&2
-	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -O \
+	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
 	  ./brz selftest -Oselftest.timeout=120 \
 	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
 	echo `date` ": selftest ends" 1>&2
@@ -353,4 +353,3 @@
 
 ### Miscellaneous Documentation Targets ###
 
-# build a png of our performance task list

=== debian/changelog ===
breezy (3.0.0~bzr6852-1) unstable; urgency=medium

  * New upstream snapshot.
  * Update homepage field.
  * debian/copyright: Fix order of paragraphs.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 04 Feb 2018 13:14:39 +0000

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
 X-Python-Version: >= 2.7
 Vcs-Bzr: https://anonscm.debian.org/bzr/pkg-bazaar/breezy/3.0
 Vcs-Browser: https://bzr.debian.org/loggerhead/pkg-bazaar/breezy/3.0
-Homepage: https://launchpad.net/brz
+Homepage: https://www.breezy-vcs.org/
 XS-Testsuite: autopkgtest
 
 Package: brz

=== debian/rules ===
#!/usr/bin/make -f

# Get the supported Python versions
PYVERS = $(shell pyversions -r -v)
# Get the default Python version
PYVERSION = $(shell pyversions -d -v)

# Callable functions to determine the correct PYTHONPATH
pythonpath = $$(ls -d $(CURDIR)/build/lib.*-$(1))
pythonpath_dbg = $$(ls -d $(CURDIR)/build/lib_d.*-$(1) 2>/dev/null || ls -d $(CURDIR)/build/lib.*$(1)-pydebug)

%:
	dh $* --with python2,sphinxdoc,bash_completion  --buildsystem=python_distutils

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
CONCURRENCY = BRZ_CONCURRENCY=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	[ -d debian/brzhome ] || mkdir debian/brzhome
	$(CONCURRENCY) \
	BRZ_HOME=debian/brzhome \
	BRZ_PLUGIN_PATH=-site:-user \
	LC_ALL=C.UTF-8 \
	PYTHONPATH=$(wildcard $(CURDIR)/build/lib.*-$(PYVERSION)) \
	$(CURDIR)/build/scripts-$(PYVERSION)/brz -Derror selftest -v --parallel=fork
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/brzhome
	rm -f brzlib/*_pyx.c
	# It also doesn't really clean every thing...
	ls doc/en/user-reference/*txt | grep -v readme.txt | xargs rm -rf
	rm -rf doc/developers/make.bat \
		doc/developers/Makefile \
		doc/*/_build/ \
		doc/en/release-notes/index.txt

override_dh_install:
	find debian/tmp/ -name "*.pyc" | xargs rm -f
	find debian/tmp/ -name "*.pyo" | xargs rm -f
	mkdir -p debian/python-breezy.tests/usr/lib \
		debian/python-breezy.tests/usr/share/pyshared/breezy
	for py in $(shell pyversions -r); do \
		mkdir -p debian/python-breezy.tests/usr/lib/$$py/dist-packages/breezy; \
		mv debian/tmp/usr/lib/$$py/dist-packages/breezy/tests \
			debian/python-breezy.tests/usr/lib/$$py/dist-packages/breezy/tests; \
	done
	if [ -d debian/tmp/usr/share/locale ]; then \
		mkdir -p debian/python-breezy/usr/share; \
		mv debian/tmp/usr/share/locale debian/python-breezy/usr/share/locale; \
	fi;
	dh_install
	# Install the documentation; since html and txt and intermixed
	# under doc/, this is handier than trying to do it from brz-doc.install.
	( cd doc && find -name "*.txt" -not -wholename "*/_build/*" -print0 ) | \
		xargs -r0 -i'{}' -n1 install -D -m 644 'doc/{}' \
		"debian/brz-doc/usr/share/doc/brz/txt/{}"

override_dh_auto_missing:
	dh_missing --fail-missing

override_dh_auto_build:
	dh_auto_build
	PYTHONHASHSEED=0 $(MAKE) docs-sphinx

override_dh_compress:
	dh_compress -X.xvg -X.pdf

override_dh_strip:
	dh_strip -ppython-breezy --dbg-package=python-breezy-dbg

override_dh_link:
	# symlink identical resources.
	( cd debian/brz-doc/usr/share/doc && fdupes -o name -r1q . | while read s; do \
	      set -- $$(echo $$s | tr ' ' '\n' | sort); \
	      f=$$1; shift; \
	      for d; do \
		  ln -sf /usr/share/doc/"$$d" "$$f"; \
	      done; \
	done )
	dh_link

override_dh_sphinxdoc:
ifneq "$(shell dh_listpackages | grep -- -doc)" ""
	dh_sphinxdoc -X searchtools.js
endif
	# dh_sphinxdoc chokes if we delete the extra licence files before it runs.
	find debian/brz-doc/usr/share/doc/brz -name "licence.txt" -print | xargs rm -f

=== debian/watch ===
version=3
opts="uversionmangle=s/rc/~rc/;s/b/.0~beta/,pgpsigurlmangle=s/$/.sig/" \
https://launchpad.net/brz/+download https://launchpad.net/brz/.*/brz-(.+).tar.gz

## breezy 3.0.0~bzr7063

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 ### Core Stuff ###
 
+SHELL=bash
 PYTHON?=python
 PYTHON3?=python3
 PYTHON24=python24
@@ -50,8 +51,8 @@
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
 	echo `date` ": selftest starts" 1>&2
-	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
-	  ./brz selftest -Oselftest.timeout=120 --load-list=python3.passing \
+	set -o pipefail; BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::PendingDeprecationWarning -Wignore::DeprecationWarning -O \
+	  ./brz selftest -Oselftest.timeout=120 --load-list=python3.passing --strict \
 	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
 	echo `date` ": selftest ends" 1>&2
 	# An empty log file should catch errors in the $(PYTHON3)
@@ -65,7 +66,7 @@
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
 	-BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
-	  ./brz selftest -Oselftest.timeout=120 \
+	  ./brz selftest -Oselftest.timeout=120 --strict \
 	  --subunit2 $(tests) > selftest.log
 	grep -v "^#" python3.passing > python3.passing.new
 	cat selftest.log | \
@@ -73,13 +74,14 @@
 	  subunit-ls --no-passthrough >> python3.passing.new
 	cp python3.passing python3.passing.old
 	grep "^#" python3.passing.old > python3.passing
-	sort -u python3.passing.new >> python3.passing
+	grep -Fvxf python3.flapping python3.passing.new > python3.passing.new.solid
+	sort -u python3.passing.new.solid >> python3.passing
 
 check-nodocs2: extensions
 	# Generate a stream for PQM to watch.
 	-$(RM) -f selftest.log
 	echo `date` ": selftest starts" 1>&2
-	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
+	set -o pipefail; BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::ImportWarning -Wignore::DeprecationWarning -O \
 	  ./brz selftest -Oselftest.timeout=120 \
 	  --subunit2 $(tests) | tee selftest.log | subunit-2to1
 	echo `date` ": selftest ends" 1>&2
@@ -90,6 +92,18 @@
 	# Check that there were no errors reported.
 	subunit-stats < selftest.log
 
+check-ci: docs extensions
+	# FIXME: Remove -Wignore::FutureWarning once
+	# https://github.com/paramiko/paramiko/issues/713 is not a concern
+	# anymore -- vila 2017-05-24
+	set -o pipefail; \
+	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
+	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --subunit2 \
+	  | subunit-filter -s --passthrough --rename "^" "python2."; \
+	  BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::PendingDeprecationWarning -Wignore::ImportWarning -O \
+	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --load-list=python3.passing --subunit2 \
+	  | subunit-filter -s --passthrough --rename "^" "python3."
+
 # Run Python style checker (apt-get install pyflakes)
 #
 # Note that at present this gives many false warnings, because it doesn't
@@ -108,7 +122,7 @@
 
 realclean: clean
 	# Remove files which are autogenerated but included by the tarball.
-	rm -f breezy/*_pyx.c
+	rm -f breezy/*_pyx.c breezy/bzr/*_pyx.c
 	rm -f breezy/_simple_set_pyx.h breezy/_simple_set_pyx_api.h
 
 # Build API documentation
@@ -150,6 +164,7 @@
 
 MAN_PAGES = man1/brz.1
 man1/brz.1: $(MAN_DEPENDENCIES)
+	mkdir -p $(dir $@)
 	$(PYTHON) tools/generate_docs.py -o $@ man
 
 
@@ -320,36 +335,3 @@
 	$(rst2html) --stylesheet=default.css $< $@
 
 doc/index.%.html: doc/index.%.txt
-	$(rst2html) --stylesheet=default.css $< $@
-
-%.html: %.txt
-	$(rst2html) --stylesheet=../../default.css $< "$@"
-
-doc/en/release-notes/NEWS.txt: $(NEWS_FILES) tools/generate_release_notes.py
-	$(PYTHON) tools/generate_release_notes.py "$@" $(NEWS_FILES)
-
-upgrade_guide_dependencies =  $(call sw,$(addsuffix /*.txt, doc/en/upgrade-guide))
-
-doc/en/upgrade-guide/index.html: $(upgrade_guide_dependencies)
-	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@
-
-derived_web_docs = $(htm_files) $(dev_htm_files) 
-WEB_DOCS = $(derived_web_docs) $(non_txt_files)
-ALL_DOCS = $(derived_web_docs) $(MAN_PAGES)
-
-# the main target to build all the docs
-docs-plain: $(ALL_DOCS)
-
-# produce a tree containing just the final docs, ready for uploading to the web
-HTMLDIR = html_docs
-html-plain: docs-plain
-	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) $(HTMLDIR)
-
-# clean produced docs
-clean-plain:
-	$(PYTHON) tools/win32/ostools.py remove $(ALL_DOCS) \
-	    $(HTMLDIR) $(derived_txt_files)
-
-
-### Miscellaneous Documentation Targets ###
-

=== breezy/plugins/git/Makefile ===
DEBUGGER ?= 
BRZ_OPTIONS ?= 
BRZ ?= $(shell which brz)
PYTHON ?= $(shell which python)
SETUP ?= ./setup.py
PYDOCTOR ?= pydoctor
CTAGS ?= ctags
PYLINT ?= pylint
RST2HTML ?= rst2html
TESTS ?= ^breezy.plugins.git. Git breezy.tests.test_info.TestInfo.test_describe_tree_format breezy.tests.test_errors.TestErrors.test_no_arg_named_message breezy.tests.test_info.TestInfo.test_describe_checkout_format
SUBUNIT_FILTER ?= subunit-filter --fixup-expected-failures=xfail --success --xfail
SUBUNIT_FORMATTER = subunit2pyunit

all:: build 

build::
	$(SETUP) build

build-inplace::

install::
	$(SETUP) install

clean::
	$(SETUP) clean
	rm -f *.so

check:: build-inplace 
	BRZ_PLUGINS_AT=git@$(shell pwd) BRZ_PLUGIN_PATH=-site:-user $(DEBUGGER) $(PYTHON) $(PYTHON_OPTIONS) $(BRZ) $(BRZ_OPTIONS) selftest --subunit2 $(TEST_OPTIONS) $(TESTS) | $(SUBUNIT_FILTER) | $(SUBUNIT_FORMATTER)

list-failing-tests:
	$(MAKE) check SUBUNIT_FILTER="subunit-filter -F" SUBUNIT_FORMATTER=subunit-ls | grep -e "^breezy\\." | sort

xfail:
	$(MAKE) -s list-failing-tests > xfail

check-all::
	$(MAKE) check TESTS="^breezy.plugins.git. Git" SUBUNIT_FILTER=cat

check-verbose::
	$(MAKE) check TEST_OPTIONS=-v

check-one::
	$(MAKE) check TEST_OPTIONS=--one

check-random::
	$(MAKE) check TEST_OPTIONS="--random=now --verbose --one"

show-plugins::
	BRZ_PLUGINS_AT=git@$(shell pwd) $(BRZ) plugins -v

lint::
	$(PYLINT) -f parseable *.py */*.py

tags::
	$(CTAGS) -R .

ctags:: tags

coverage::
	$(MAKE) check BRZ_OPTIONS="--coverage coverage"

.PHONY: update-pot po/brz-git.pot
update-pot: po/brz-git.pot

TRANSLATABLE_PYFILES:=$(shell find . -name '*.py' \
		| grep -v 'tests/' \
		)

po/brz-git.pot: $(PYFILES) $(DOCFILES)
	BRZ_PLUGINS_AT=git@$(shell pwd) brz export-pot \
          --plugin=git > po/brz-git.pot
	echo $(TRANSLATABLE_PYFILES) | xargs \
	xgettext --package-name "brz-git" \
	  --msgid-bugs-address "<bazaar@lists.canonical.com>" \
	  --copyright-holder "Canonical Ltd <canonical-bazaar@lists.canonical.com>" \
	  --from-code ISO-8859-1 --sort-by-file --join --add-comments=i18n: \
	  -d brz-git -p po -o brz-git.pot

.PHONY: xfail

=== debian/changelog ===
breezy (3.0.0~bzr7063-1) unstable; urgency=medium

  * New upstream snapshot.
   + Drop patch 02_diff_language: applied upstream.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 08 Aug 2018 02:57:13 +0100

breezy (3.0.0~bzr6988-1) unstable; urgency=medium

  * Fix Vcs-Bzr URL.
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 15 Jun 2018 15:47:12 +0100

breezy (3.0.0~bzr6977-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 31 May 2018 01:19:35 +0100

breezy (3.0.0~bzr6964-1) unstable; urgency=medium

  * debian/tests: Run breezy rather than bazaar testsuite.
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 14 May 2018 13:21:58 +0100

breezy (3.0.0~bzr6961-1) unstable; urgency=medium

  * New upstream snapshot.
   + Bundles git support. Add dependency on python-dulwich.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 10 May 2018 03:08:18 +0100

breezy (3.0.0~bzr6948-1) unstable; urgency=medium

  * Update Vcs-Bzr and Vcs-Browser headers.
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 05 May 2018 20:03:40 +0100

breezy (3.0.0~bzr6940-1) unstable; urgency=medium

  * Install the bash completion script.
  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 07 Apr 2018 00:38:43 +0100

breezy (3.0.0~bzr6928-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 26 Mar 2018 02:04:52 +0100

breezy (3.0.0~bzr6876-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 04 Mar 2018 19:29:40 +0000

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,9 @@
                python-all-dbg (>= 2.6.6-3),
                python-all-dev (>= 2.6.6-3),
                python-configobj (>= 4.7.2+ds-2),
+               python-dulwich (>= 0.19.1),
                python-docutils,
-               python-fastimport,
+               python-fastimport (>= 0.9.8),
                python-lzma-dbg [!m68k !powerpcspe !sh4],
                python-meliae-dbg,
                python-paramiko (<< 1.12.0) | python-paramiko (>= 1.14.1),
@@ -23,13 +24,13 @@
 Build-Conflicts: python-pyftpdlib
 Standards-Version: 4.1.1
 X-Python-Version: >= 2.7
-Vcs-Bzr: https://anonscm.debian.org/bzr/pkg-bazaar/breezy/3.0
-Vcs-Browser: https://bzr.debian.org/loggerhead/pkg-bazaar/breezy/3.0
+Vcs-Bzr: https://code.breezy-vcs.org/breezy/unstable
+Vcs-Browser: https://code.breezy-vcs.org/breezy/unstable
 Homepage: https://www.breezy-vcs.org/
 XS-Testsuite: autopkgtest
 
 Package: brz
-Recommends: python-gpg
+Recommends: python-gpg, python-dulwich (>= 0.19.1)
 Architecture: all
 Depends: python-breezy (<= ${source:Version}.1~),
          python-breezy (>= ${source:Version}),
@@ -38,7 +39,7 @@
 Conflicts: bzr (<< 2.7.0+bzr6622-1)
 Suggests: brz-doc,
           python-breezy.tests,
-          python-fastimport
+          python-fastimport (>= 0.9.8)
 Description: easy to use distributed version control system
  Breezy is a distributed version control system designed to be easy to
  use and intuitive, able to adapt to many workflows, reliable, and
@@ -66,7 +67,8 @@
          ${shlibs:Depends}
 Recommends: ca-certificates,
             python-launchpadlib,
-            ssh-client | python-paramiko
+            ssh-client | python-paramiko,
+            python-dulwich (>= 0.19.1)
 Conflicts: python-paramiko (<< 1.14.1)
 Suggests: python-breezy-dbg,
           python-breezy.tests,

=== debian/tests/control ===
Tests: testsuite
Depends: brz, python-breezy.tests, python-subunit, ca-certificates, python-meliae, python-lzma, python-pycurl, python-medusa
Restrictions: allow-stderr
